"{ Package: 'stx:goodies/monticello' }"

LibraryDefinition subclass:#stx_goodies_monticello
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_monticello class methodsFor:'documentation'!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/goodies/monticello/stx_goodies_monticello.st,v 1.9 2011-08-25 16:08:42 vrany Exp $'
! !

!stx_goodies_monticello class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/communication'    "HTTPInterface - referenced by MCHttpRepository>>allFileNames "
        #'stx:libbasic'    "Object - superclass of MCAncestry "
        #'stx:libbasic2'    "UUID - referenced by MCWorkingAncestry>>infoWithName:message: "
        #'stx:libbasic3'    "AbstractSourceCodeManager - superclass of MCSourceCodeManager "
        #'stx:libcomp'    "Scanner - referenced by MCSystemCategoryParser>>category "
        #'stx:libcompat'    "PackageInfo - superclass of MCDirtyPackageInfo "
        #'stx:libtool'    "Tools::NavigatorModel - superclass of MCRepositoryList "
        #'stx:libview'    "Depth1Image - referenced by MCDialog class>>downArrow "
        #'stx:libview2'    "Model - superclass of MCDialog "
        #'stx:libwidg'    "PopUpMenu - referenced by MCVersionInspector>>pickAncestor "
        #'stx:libwidg2'    "HierarchicalItem - superclass of MCRepositoryEntry "
    )
! !

!stx_goodies_monticello class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        InMidstOfFileinNotification
        MCAncestry
        MCBrowserList
        MCChangeSelectionRequest
        (MCChangeSelector autoload)
        MCConflict
        MCDefinition
        MCDefinitionIndex
        MCDependencySorter
        (MCDependentsWrapper autoload)
        MCDialog
        MCDirtyPackageInfo
        MCDoItParser
        MCEmptyPackageInfo
        (MCFileRepositoryInspector autoload)
        MCFrontier
        MCInteractiveLoadingQuery
        MCLazyPropertyDictionary
        (MCMergeBrowser autoload)
        MCMergeRecord
        MCMergeResolutionRequest
        MCMerger
        MCMock
        MCMockAPoolDictionary
        MCMockClassD
        MCMockClassE
        MCMockClassF
        MCMockClassG
        MCMockClassH
        MCMockClassI
        MCMockDependency
        MCMockPackageInfo
        MCNoChangesException
        MCPackage
        MCPackageCache
        MCPackageEntry
        MCPackageLoader
        MCPackageManager
        MCPatch
        MCPatchOperation
        MCPatcher
        MCReader
        MCRepository
        MCRepositoryBrowser
        MCRepositoryEntry
        MCRepositoryGroup
        (MCRepositoryInspector autoload)
        (MCSMCacheRepository autoload)
        (MCSaveVersionDialog autoload)
        MCScanner
        MCSettingsApp
        MCSnapshot
        (MCSnapshotBrowser autoload)
        MCSourceCodeManager
        MCStXPackageQuery
        MCTimestampAnnotation
        MCTool
        (MCToolWindowBuilder autoload)
        MCVariableDefinition
        MCVersion
        MCVersionDependency
        MCVersionEntry
        MCVersionLoader
        MCVersionMerger
        MCVersionNameAndMessageRequest
        MCVersionNotification
        MCVersionSorter
        (MCWorkingCopyBrowser autoload)
        (MCWorkingHistoryBrowser autoload)
        MCWriter
        MethodReference
        PackageOrganizer
        #'stx_goodies_monticello'
        MCAddition
        MCClassDefinition
        MCClassInstanceVariableDefinition
        MCClassTraitDefinition
        MCClassTraitParser
        MCClassVariableDefinition
        MCCodeTool
        MCCommitDialog
        MCDictionaryRepository
        MCDiffyVersion
        MCFileBasedRepository
        MCFilteredVersionSorter
        MCGOODSRepository
        MCInstanceVariableDefinition
        MCMczWriter
        MCMethodDefinition
        MCMockClassA
        MCMockClassB
        MCMockDefinition
        MCMockDependentItem
        MCModification
        MCMultiPackageLoader
        MCOrganizationDefinition
        MCPackageList
        MCPoolImportDefinition
        MCRemoval
        MCRepositoryDialog
        MCRepositoryList
        MCScriptDefinition
        MCSnapshotReader
        MCStWriter
        MCSystemCategoryParser
        MCThreeWayMerger
        MCTraitParser
        MCVersionHistoryBrowser
        MCVersionInfo
        MCVersionInfoWriter
        MCVersionInspector
        MCVersionList
        MCVersionReader
        MCWorkingAncestry
        MCWorkingCopy
        MCWriteOnlyRepository
        MCDirectoryRepository
        MCFtpRepository
        MCHttpRepository
        MCLazyVersionInfo
        MCMcdWriter
        MCMczReader
        MCMockASubclass
        MCPatchBrowser
        MCPostscriptDefinition
        MCPreambleDefinition
        MCRemovalPostscriptDefinition
        MCRemovalPreambleDefinition
        MCSMReleaseRepository
        MCSmtpRepository
        MCStReader
        MCTraitDefinition
        MCCacheRepository
        MCMcdReader
        MCSubDirectoryRepository
        MCStXPackageInfo
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        Behavior includesLocalSelector:
        Behavior localSelectors
        Behavior traitCompositionString
        Behavior typeOfClass
        Change mcDefinition
        Change mcDefinition:
        Class asClassDefinition
        Class classDefinitions
        Class poolDictionaryNames
        ClassBuilder name:inEnvironment:subclassOf:type:instanceVariableNames:classVariableNames:poolDictionaries:category:
        ClassDescription mcDefinition
        Object isConflict
        SequenceableCollection copyReplaceAll:with:asTokens:
        Stream isMessageStream
        String asStringWithNativeLineEndings
        String asStringWithSqueakLineEndings
        String extractNumber
        String withSqueakLineEndings
        StringCollection asStringWithNativeLineEndings
        StringCollection asStringWithSqueakLineEndings
        Symbol isDoIt
        #'Tools::NewSystemBrowser' projectMenuMonticelloCommit
        UndefinedObject typeOfClass
        UserPreferences mcEnabled
        UserPreferences mcEnabled:
        UserPreferences mcRepositories
        UserPreferences mcRepositories:
        VersionInfo timeStamp
        'Annotation class' mctimestamp:
        'ProjectDefinition class' #'monticelloTimestamps_code'
        'ProjectDefinition class' #'monticelloTimestamps_codeFor:'
        'Timestamp class' fromMethodTimeStamp:
        'Tools::NewSystemBrowser class' projectMonticelloMenu
    )
! !

!stx_goodies_monticello class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Monticello Class library'

    "Modified: / 20-08-2011 / 16:57:40 / cg"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Public - See SqueakSource'

    "Modified: / 20-08-2011 / 16:58:01 / cg"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_monticello class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/monticello/stx_goodies_monticello.st,v 1.9 2011-08-25 16:08:42 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/monticello/stx_goodies_monticello.st,v 1.9 2011-08-25 16:08:42 vrany Exp $'
! !
